<template>
  <b-container class="full-width-container">
    <b-container class="full-width-container">
      <div v-if="status === Status.LOADING">
        <content-loader-table :num-rows="10" />
      </div>
      <div v-else-if="status === Status.ERROR">
        <b-list-group>
          <b-list-group-item variant="danger">
            <h5>Error Loading Announcements</h5>
            <p>There was an error loading our announcements.</p>
            <pre>{{ JSON.stringify(error, null, 2) }}</pre>
          </b-list-group-item>
        </b-list-group>
      </div>
      <div v-show="status === Status.SUCCESS">
        <b-alert
          v-model="showErrorMessage"
          class="mb-2"
          dismissible
          variant="danger"
        >
          {{ errorMessage }}
        </b-alert>
        <div class="d-flex justify-content-between">
          <div>
            <b-button
              :to="{ name: 'announcementCreate' }"
              size="sm"
              variant="success"
            >
              <font-awesome-icon icon="plus" />
            </b-button>
          </div>
          <div class="d-flex align-items-baseline">
            <b-form inline>
              <b-form-select
                v-model="perPage"
                :options="pageOptions"
                class="mr-2"
                size="sm"
              />
            </b-form>
            <b-pagination
              v-model="currentPage"
              :per-page="perPage"
              :total-rows="count"
              align="right"
              size="sm"
            />
          </div>
        </div>
        <b-table
          ref="announcementTable"
          :current-page="currentPage"
          :fields="fields"
          :items="fetchAnnouncements"
          :per-page="perPage"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          bordered
          hover
          small
          td-class="table-cell"
        >
          <template #cell(active)="data">
            <b-form-checkbox
              v-model="data.item.active"
              :disabled="submitting"
              class="text-center"
              switch
              @change="$event ? makeActive(data.item) : makeInactive(data.item)"
            />
          </template>
          <template #cell(message)="data">
            <div
              style="
                max-width: 600px;
                overflow: hidden;
                white-space: nowrap;
                text-overflow: ellipsis;
              "
            >
              {{ data.value }}
            </div>
          </template>
        </b-table>
      </div>
    </b-container>
  </b-container>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
import Vue from 'vue';
import { BvTableCtxObject } from 'bootstrap-vue';

import { FETCH_ANNOUNCEMENTS } from '@/store/actions';
import { AnnouncementService } from '@/api';
import { Announcement } from '@/common/types';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  ERROR = 'ERROR',
  LOADING = 'LOADING',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
  },

  data() {
    return {
      Status,
      count: 0,
      currentPage: 1,
      error: {},
      errorMessage: '',
      fields: [
        {
          key: 'created_at',
          label: 'Created At (UTC)',
          sortable: true,
        },
        {
          key: 'active',
          label: 'Active',
          sortable: true,
        },
        {
          key: 'message',
          label: 'message',
          sortable: true,
        },
        {
          key: 'variant',
          label: 'Type',
          sortable: true,
        },
      ],
      showErrorMessage: false,
      sortBy: 'active',
      sortDesc: true,
      status: Status.LOADING,
      submitting: false,
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 5,
    };
  },

  computed: {
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    rows(): number {
      return this.count;
    },
  },

  methods: {
    async fetchAnnouncements(ctx: BvTableCtxObject) {
      this.status = Status.LOADING;
      try {
        const { data: announcements, meta } = await AnnouncementService.list({
          page: {
            limit: ctx.perPage,
            offset: (ctx.currentPage - 1) * ctx.perPage,
          },
          ...(ctx.sortBy && { sort: (ctx.sortDesc ? '-' : '') + ctx.sortBy }),
        });
        this.count = meta.count;
        this.status = Status.SUCCESS;
        return announcements;
      } catch (errors) {
        /* eslint-disable-next-line prefer-destructuring */
        this.error = errors[0];
        this.status = Status.ERROR;
      }
      return null;
    },
    async makeActive(announcement: Announcement) {
      this.submitting = true;
      try {
        await AnnouncementService.makeActive(announcement.id);
        await (<any> this.$refs.announcementTable).refresh();
      } catch (error) {
        this.errorMessage = JSON.stringify(error, null, 2);
        this.showErrorMessage = true;
        announcement.active = false;
      }
      this.$store.dispatch(FETCH_ANNOUNCEMENTS);
      this.submitting = false;
    },
    async makeInactive(announcement: Announcement) {
      this.submitting = true;
      try {
        await AnnouncementService.makeInactive(announcement.id);
        await (<any> this.$refs.announcementTable).refresh();
      } catch (error) {
        this.errorMessage = JSON.stringify(error, null, 2);
        this.showErrorMessage = true;
        announcement.active = true;
      }
      this.$store.dispatch(FETCH_ANNOUNCEMENTS);
      this.submitting = false;
    },
  },
});
</script>

<style scoped>
.no-content {
  margin-top: 100px;
}
table-cell {
  cursor: pointer;
}
</style>
